
(setq NAME "Rubik's Magic")

(setq DDKB "GENERIC")

(setq VARIABLES '(sF s11T s11L s11B s11R
		     s12T s12L s12B s12R
		     s13T s13L s13B s13R
		     s14T s14L s14B s14R
		     s21T s21L s21B s21R
		     s22T s22L s22B s22R
		     s23T s23L s23B s23R
		     s24T s24L s24B s24R
		     s32T s32L s32B s32R
		     s33T s33L s33B s33R))
		     
(setq CONSTANTS '(REC SQR BLANK))

(setq PREDICATES '(EQ NE))

(setq FUNCTIONS nil)

(setq OPERATORS '((o21 ((EQ sF REC)) ; rotate some tiles 90 degree
		       (s11T s12L) (s11L s12B) (s11B s12R) (s11R s12T)
		       (s12T s11R) (s12L s11T) (s12B s11L) (s12R s11B)
		       (s13T s21R) (s13L s21T) (s13B s21L) (s13R s21B)
		       (s14T s22L) (s14L s22B) (s14B s22R) (s14R s22T)
		       (s21T s13L) (s21L s13B) (s21B s13R) (s21R s13T)
		       (s22T s14R) (s22L s14T) (s22B s14L) (s22R s14B)
		       (s23T s24R) (s23L s24T) (s23B s24L) (s23R s24B)
		       (s24T s23L) (s24L s23B) (s24B s23R) (s24R s23T))
		       
		  (o22 ((EQ sF REC)) ; flip four tiles
		       (s11T s13T) (s11L s13L) (s11B s13B) (s11R s13R)
		       (s12T s14T) (s12L s14L) (s12B s14B) (s12R s14R)
		       (s13T s24B) (s13L s24R) (s13B s24T) (s13R s24L)
		       (s14T s23B) (s14L s23R) (s14B s23T) (s14R s23L)
		       (s21T s12B) (s21L s12R) (s21B s12T) (s21R s12L)
		       (s22T s11B) (s22L s11R) (s22B s11T) (s22R s11L)
		       (s23T s21T) (s23L s21L) (s23B s21B) (s23R s21R)
		       (s24T s22T) (s24L s22L) (s24B s22B) (s24R s22R))

		  (o23 ((EQ sF REC)) ; switch lower and upper halves
		       (s11T s21T) (s11L s21L) (s11B s21B) (s11R s21R)
		       (s12T s22T) (s12L s22L) (s12B s22B) (s12R s22R)
		       (s13T s23T) (s13L s23L) (s13B s23B) (s13R s23R)
		       (s14T s24T) (s14L s24L) (s14B s24B) (s14R s24R)
		       (s21T s11T) (s21L s11L) (s21B s11B) (s21R s11R)
		       (s22T s12T) (s22L s12L) (s22B s12B) (s22R s12R)
		       (s23T s13T) (s23L s13L) (s23B s13B) (s23R s13R)
		       (s24T s14T) (s24L s14L) (s24B s14B) (s24R s14R))
		     
		  (o24 ((EQ sF REC)) ; flip two tiles
		       (s11T s11B) (s11L s11R) (s11B s11T) (s11R s11L)
		       (s12T s21T) (s12L s21L) (s12B s21B) (s12R s21R)
		       (s13T s22T) (s13L s22L) (s13B s22B) (s13R s22R)
		       (s14T s23T) (s14L s23L) (s14B s23B) (s14R s23R)
		       (s21T s12T) (s21L s12L) (s21B s12B) (s21R s12R)
		       (s22T s13T) (s22L s13L) (s22B s13B) (s22R s13R)
		       (s23T s14T) (s23L s14L) (s23B s14B) (s23R s14R)
		       (s24T s24B) (s24L s24R) (s24B s24T) (s24R s24L))

		  (o25 ((EQ sF REC)) ; flip other two tiles
		       (s11T s22T) (s11L s22L) (s11B s22B) (s11R s22R)
		       (s12T s23T) (s12L s23L) (s12B s23B) (s12R s23R)
		       (s13T s24T) (s13L s24L) (s13B s24B) (s13R s24R)
		       (s14T s14B) (s14L s14R) (s14B s14T) (s14R s14L)
		       (s21T s21B) (s21L s21R) (s21B s21T) (s21R s21L)
		       (s22T s11T) (s22L s11L) (s22B s11B) (s22R s11R)
		       (s23T s12T) (s23L s12L) (s23B s12B) (s23R s12R)
		       (s24T s13T) (s24L s13L) (s24B s13B) (s24R s13R))
		       
		  (oRS ((EQ sF REC)) ; Rectangular to Square
		       (sF SQR)
		       (s23T s14B) (s23L s14R) (s23B s14T) (s23R s14L)
		       (s32T s23B) (s32L s23R) (s32B s23T) (s32R s23L)
		       (s33T s24B) (s33L s24R) (s33B s24T) (s33R s24L)
		       (s14T s32B) (s14L s32R) (s14B s32T) (s14R s32L)
		       (s24T s33B) (s24L s33R) (s24B s33T) (s24R s33L))
		       
		  (oSR ((EQ sF SQR)) ; Square to Rectangular
		       (sF REC)
		       (s14T s23B) (s14L s23R) (s14B s23T) (s14R s23L)
		       (s23T s32B) (s23L s32R) (s23B s32T) (s23R s32L)
		       (s24T s33B) (s24L s33R) (s24B s33T) (s24R s33L)
		       (s32T s14B) (s32L s14R) (s32B s14T) (s32R s14L)
		       (s33T s24B) (s33L s24R) (s33B s24T) (s33R s24L))))

(setq INITIAL nil)

(setq GOAL '((EQ sF SQR)
	     (EQ s11T BLANK) (EQ s11L BLANK) (EQ s11B s21T) (EQ s11R s12L)
	     (EQ s12T BLANK) (EQ s12B s22T) (EQ s12R s13L)
	     (EQ s13T BLANK) (EQ s13B s23T) (EQ s13R BLANK)
	     (EQ s21L BLANK) (EQ s21B BLANK) (EQ s21R s22L)
	     (EQ s22B s32T) (EQ s22R s23L)
	     (EQ s23B s33T) (EQ s23R BLANK)
	     (EQ s32L BLANK) (EQ s32B BLANK) (EQ s32R s33L)
	     (EQ s33B BLANK) (EQ s33R BLANK)))

